#!perl

use strict;

print qq|/*
 * Autogenerated file.
 * Generated by iconv_charsets.pl
 */

|;

# ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP1252.TXT
my %cp1252 = (
	0x80 => 8364,
	0x82 => 8218,
	0x83 => 402,
	0x84 => 8222,
	0x85 => 8230,
	0x86 => 8224,
	0x87 => 8225,
	0x88 => 710,
	0x89 => 8240,
	0x8A => 352,
	0x8B => 8249,
	0x8C => 338,
	0x8E => 381,
	0x91 => 8216,
	0x92 => 8217,
	0x93 => 8220,
	0x94 => 8221,
	0x95 => 8226,
	0x96 => 8211,
	0x97 => 8212,
	0x98 => 732,
	0x99 => 8482,
	0x9A => 353,
	0x9B => 8250,
	0x9C => 339,
	0x9E => 382,
	0x9F => 376,
);

# some checks
while (my ($from, $to) = each %cp1252)
{
	die if $from < 0x80 || $from >= 0xa0;
	die if $to < 0x100 || $to > 0x10000;
}

# print CP1252 define and table
print "#define CP1252_ALL";
my $table = '';
for my $n (0x80 .. 0x9f)
{
	$table .= sprintf("\t0x%x,\n", exists($cp1252{$n}) ? $cp1252{$n} : $n);
	printf(" \\\n\tCP1252(0x%x, %d)", $n, $cp1252{$n}) if exists($cp1252{$n});
}

print qq|

static const uint16_t cp1252_0080_00a0[] = {
$table};

TDS_COMPILE_CHECK(cp1252size, sizeof(cp1252_0080_00a0) == 0x20*sizeof(uint16_t));
|;
